;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;			Bettina McCormick
;
;			COP 4020 SUM '98
;
;			LAB 1 - Due June15, 1998
;
;			LISP Functions
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;






;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab1: part one ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun KeepAtoms (L) ;returns a list equivalent to L but containing only atoms in L.
	(cond
   		( (null L) NIL)
		( (null (atom (car L))) (KeepAtoms(cdr L)))
   		(T (cons (car L) (KeepAtoms(cdr L))))
  	)
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab1: part two ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun IsNumber (X) ;returns a list with the label 'NUMBER and X.
          (list (quote NUMBER) X) 
)

(defun IsLetter (X) ;returns a list with the label 'LETTER and X.
          (list (quote LETTER) X) 
)

(defun MakeLabels (X) ;returns the approprate list.
          (cond
		((numberp X) (IsNumber X))
		(T (IsLetter X)) 
	  ) 
)

(defun PutLabel (L) ;returns a list with a label in front of each element of L.
          (cond
		((null L) NIL)
		(T (mapcar (function MakeLabels) L)) 
	  ) 
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab1: part three ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun Unique (L) ;returns a listof elements of L that occur only once in L.
     (cond
          ( (null L) NIL)
          ((member (car L) (cdr L)) (Unique (remove (car L) L)))
 	  (T (cons (car L) (Unique (cdr L))))		    
     )
)

